## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.7

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# DOMStringHelper.hpp File Reference

Include dependency graph for DOMStringHelper.hpp:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Compounds

- struct c_wstr_functor
- struct DOMStringEqualsFunction
- struct DOMStringGreaterThanFunction
- struct DOMStringGreaterThanOrEqualFunction
- struct DOMStringHashFunction
- class DOMStringHelper
- struct DOMStringLessThanFunction
- struct DOMStringLessThanIgnoreCaseASCIIFunction
- struct DOMStringLessThanOrEqualFunction
- struct DOMStringNotEqualsFunction
- struct DOMStringPointerLessThanFunction
- struct less_no_case_ascii_wide_string

## Defines

- #define DOMSTRINGHELPER_HEADER_GUARD_1357924680
- #define XALAN_STATIC_UCODE_STRING(str) XALAN_CPP_NAMESPACE_QUALIFIER TranscodeFromLocalCodePage(str)

## Functions

- const XalanDOMString& StaticStringToDOMString (const XalanDOMString& theString)
    Determines if a range in an array contains only whitespace. More...
- template<classInputIteratorType, classOutputIteratorType> OutputIteratorType XalanCopy ( InputIteratorType begin, InputIteratorType end, OutputIteratorType iterator)
- template<classInputIteratorType, classOutputIteratorType, classUnaryFunction> OutputIteratorType XalanTransform ( InputIteratorType begin, InputIteratorType end, OutputIteratorType iterator, UnaryFunction function)
- const XalanDOMChar* c_wstr (const XalanDOMString& theString)
    Get the underlying representation of the target XalanDOMString as a null-terminated string. More...
- const char* c_str (const CharVectorType& theString)
    Get the underlying representation of the target CharVectorType as a null-terminated string. More...
- const XalanDOMChar* c_wstr (const XalanDOMChar* theString)
    Get the underlying representation of the wide string as a UNICODE null-terminated string. More...
- const XalanDOMChar* toCharArray (const XalanDOMString& theString)
    Get the underlying representation of the target XalanDOMString as an array of XalanDOMChar, not guaranteed to be null-terminated. More...
- const XalanDOMChar* toCharArray (const XalanDOMChar* theString)
    Get the underlying representation of a XalanDOMChar. More...
- const char* toCharArray (const CharVectorType& theString)
    Get the underlying representation of the target CharVectorType as a pointer to an array of characters. More...
- void reserve ( XalanDOMString& theString, XalanDOMString::size_type theCount)
    Reserve some space in the string for more efficient concatenation... More...
- XalanDOMString::size_type length (const XalanDOMString& theString)
    Get the length of a XalanDOMString. More...
- XalanDOMString::size_type length (const XalanDOMChar* theString)
    Get the length of a null-terminated string of XalanDOMChar characters. More...
- XalanDOMString::size_type length (const char* theString)
    Get the length of a null-terminated string. More...
- bool isEmpty (const XalanDOMString& str)
    Determines if the target string contains any elements. More...
- XalanDOMString::size_type indexOf ( const XalanDOMChar* theString, XalanDOMChar theChar)
    Simulates the java String method indexOf(). More...
- XalanDOMString::size_type indexOf ( const XalanDOMChar* theString, XalanDOMString::size_type theStringLength, XalanDOMChar theChar)
    Simulates the java String method indexOf(). More...
- XalanDOMString::size_type indexOf ( const XalanDOMString& theString, XalanDOMChar theChar)
    Simulates the java String method indexOf(). More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (XalanDOMString::size_type) indexOf( const XalanDOMChar* theString, XalanDOMString
    Simulates the java String method indexOf(). More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (bool) startsWith( const XalanDOMChar* theString, XalanDOMString
    Simulates the java String method startsWith(). More...
- bool startsWith ( const XalanDOMChar* theString, const XalanDOMString& theSubstring)
    Simulates the java String method startsWith(). More...
- bool startsWith ( const XalanDOMString& theString, const XalanDOMChar* theSubstring)
    Simulates the java String method startsWith(). More...
- bool startsWith ( const XalanDOMString& theString, const XalanDOMChar* theSubstring, XalanDOMString::size_type theSubstringLength)
    Simulates the java String method startsWith(). More...
- bool startsWith ( const XalanDOMString& theString, const XalanDOMString& theSubstring)
    Simulates the java String method startsWith(). More...
- bool startsWith ( const XalanDOMString& theString, const char* theSubstring)
    Simulates the java String method startsWith(). More...
- bool endsWith ( const XalanDOMString& theString, const XalanDOMString& theSubstring)
    Simulates the java String method endsWith(). More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (XalanDOMString&) PointerToDOMString( const void* theValue, XalanDOMString& theResult)
    Converts a pointer into a XalanDOMString. More...
- const XalanDOMString PointerToDOMString (const void* theValue)
    Converts a pointer into a XalanDOMString. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (XalanDOMString&) DoubleToDOMString( double theValue, XalanDOMString& theResult)
    Converts a double value into a XalanDOMString. More...
- const XalanDOMString DoubleToDOMString (double theValue)
    Converts a double value into a XalanDOMString. More...
- const XalanDOMString LongToHexDOMString (long theValue)
    Converts a long value into a XalanDOMString. More...
- const XalanDOMString UnsignedLongToHexDOMString (unsigned long theValue)
    Converts an unsigned long value and appends the result to a XalanDOMString. More...
- const XalanDOMString LongToDOMString (long theValue)
    Converts a long value into a XalanDOMString. More...
- const XalanDOMString UnsignedLongToDOMString (unsigned long theValue)
    Converts an unsigned long value into a XalanDOMString. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (int) WideStringToInt( const XalanDOMChar* theString)
    Converts a wide string into an integer value. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (long) WideStringToLong( const XalanDOMChar* theString)
    Converts a wide string into a long value. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (unsigned long) WideStringToUnsignedLong( const XalanDOMChar* theString)
    Converts a wide string into an unsigned long value. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (double) WideStringToDouble( const XalanDOMChar* theString)
    Converts a wide string into a double value. More...
- int DOMStringToInt (const XalanDOMString& theString)
    Converts a XalanDOMString into an integer value. More...
- long DOMStringToLong (const XalanDOMString& theString)
    Converts a XalanDOMString into a long value. More...
- unsigned long DOMStringToUnsignedLong (const XalanDOMString& theString)
    Converts a XalanDOMString into a long value. More...
- double DOMStringToDouble (const XalanDOMString& theString)
    Converts a XalanDOMString into a double value. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (void) OutputString( XalanOutputStream& theStream, const CharVectorType& theString)
    Outputs the target string to the specified stream. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (void) OutputString( std
    Outputs the target string to the specified stream. More...
- void OutputString ( std::ostream& theStream, const XalanDOMString& theString)
    Outputs the target string to the specified stream. More...
- XalanOutputStream& operator<< ( XalanOutputStream& theStream, const CharVectorType& theString)
    Outputs the string to the specified stream. More...
- std::ostream& operator<< ( std::ostream& theStream, const CharVectorType& theString)
    Outputs the string to the specified stream. More...
- XalanOutputStream& operator<< ( XalanOutputStream& theStream, const XalanDOMChar* theString)
    Outputs the target string to the specified stream. More...
- std::ostream& operator<< ( std::ostream& theStream, const XalanDOMChar* theString)
    Outputs the target string to the specified stream. More...
- XalanOutputStream& operator<< ( XalanOutputStream& theStream, const XalanDOMString& theString)
    Outputs the target string to the specified stream. More...
- std::ostream& operator<< ( std::ostream& theStream, const XalanDOMString& theString)
    Outputs the target string to the specified stream. More...
- XalanDOMChar charAt ( const XalanDOMString& theString, XalanDOMString::size_type theIndex)
    Retrieves a character at a specified index in the target string. More...
- bool isXMLWhitespace (XalanDOMChar theChar)
    Determines whether character represents white space. More...
- bool isXMLDigit (XalanDOMChar theChar)
    Determines whether character represents a digit. More...
- bool isXMLLetterOrDigit (XalanDOMChar theChar)
    Determines whether character represents a letter or digit. More...
- XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION (XalanDOMString) substring( const XalanDOMChar* theString, XalanDOMString
    Simulates the java String method substring(). More...
- XalanDOMChar toUpperASCII (XalanDOMChar theChar)
    Converts ASCII alphabetic characters from lower case to upper case. More...
- int compare ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings. More...
- int compare ( const XalanDOMChar* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings. More...
- int compare ( const XalanDOMString& theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings. More...
- int compareIgnoreCaseASCII ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings, in a case insensitive manner. More...
- int compareIgnoreCaseASCII ( const XalanDOMString& theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings, in a case insensitive manner. More...
- int compareIgnoreCaseASCII ( const XalanDOMChar* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings, in a case insensitive manner. More...
- int collationCompare ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings. More...
- int collationCompare ( const XalanDOMChar* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings. More...
- int collationCompare ( const XalanDOMString& theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings. More...
- bool equals ( const XalanDOMChar* theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings for equality. More...
- bool equals ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings for equality. More...
- bool equals ( const XalanDOMChar* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings for equality. More...
- bool equals (const XalanDOMString& theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings for equality. More...
- bool equals ( const XalanDOMString& theLHS, const XalanDOMChar* theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two strings for equality. More...
- bool equals (const XalanDOMString& theLHS, const char* theRHS)
    Compare the contents of two strings for equality. More...
- bool equals (const char* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings for equality. More...
- bool equals (const XalanDOMChar* theLHS, const char* theRHS)
    Compare the contents of two strings for equality. More...
- bool equals (const char* theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings for equality. More...
- bool equalsIgnoreCaseASCII ( const XalanDOMChar* theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings for equality, without regard for case. More...
- bool equalsIgnoreCaseASCII ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings for equality, without regard for case Only the characters A-Z and a-z are considered. More...
- bool equalsIgnoreCaseASCII ( const XalanDOMChar* theLHS, const XalanDOMString& theRHS)
    Compare the contents of two strings for equality, without regard for case. More...
- bool equalsIgnoreCaseASCII ( const XalanDOMString& theLHS, const XalanDOMChar* theRHS)
    Compare the contents of two strings for equality, without regard for case. More...
- bool operator< ( const CharVectorType& theLHS, const CharVectorType& theRHS)
    Implements operator< for CharVectorType. More...
- bool operator< ( const XalanDOMString& theLHS, const XalanDOMString& theRHS)
    Implements operator< for DOMStrings. More...
- XalanDOMString& assign ( XalanDOMString& theString, const XalanDOMString& theStringToAssign)
    Assign one string to another. More...
- XalanDOMString& assign ( XalanDOMString& theString, const XalanDOMChar* theStringToAssign, XalanDOMString::size_type theStringToAssignLength = XalanDOMString::npos)
    Assign one string to another. More...
- XalanDOMString& append ( XalanDOMString& theString, const XalanDOMString& theStringToAppend)
    Concatenate two strings. More...
- XalanDOMString& append ( XalanDOMString& theString, const XalanDOMChar* theStringToAppend, XalanDOMString::size_type theStringToAppendLength = XalanDOMString::npos)
    Concatenate two strings. More...
- XalanDOMString& append ( XalanDOMString& theString, const char* theStringToAppend, XalanDOMString::size_type theStringToAppendLength = XalanDOMString::npos)
    Concatenate two strings. More...
- XalanDOMString& append ( XalanDOMString& theString, const XalanDOMChar theCharToAppend)
    Concatenate a string and a character. More...
- XalanDOMString& append ( XalanDOMString& theString, char theCharToAppend)
    Concatenate a string and a character. More...
- XalanDOMString& insert ( XalanDOMString& theString, XalanDOMString::size_type thePosition, const XalanDOMString& theStringToInsert)
    Insert a string into another string. More...
- XalanDOMString& insert ( XalanDOMString& theString, XalanDOMString::size_type thePosition, const XalanDOMChar* theStringToInsert)
    Insert a string into another string. More...
- void clear (XalanDOMString& theString)
    Remove all elements from target string. More...
- void erase (XalanDOMString& theString)
    Remove all elements from target string. More...
- void releaseMemory (XalanDOMString& theString)
    Remove all elements from target string and frees all allocated memory. More...
- XalanDOMCharVectorType MakeXalanDOMCharVector (const XalanDOMString& data)
    Utility function to make a null-terminated vector of XMLChs, from a XalanDOMString. More...

## Variables

- XALAN_CPP_NAMESPACE_BEGIN
  class XalanOutputStream

## Define Documentation

#define DOMSTRINGHELPER_HEADER_GUARD_1357924680

#define XALAN_STATIC_UCODE_STRING( | str ) XALAN_CPP_NAMESPACE_QUALIFIER TranscodeFromLocalCodePage(str)

## Function Documentation

double DOMStringToDouble ( | const XalanDOMString & theString )`[]`

Converts a XalanDOMString into a double value.

Parameters:

  theString | target string

Returns:
  double value of target string

int DOMStringToInt ( | const XalanDOMString & theString )`[]`

Converts a XalanDOMString into an integer value.

Parameters:

  theString | target string

Returns:
  integer value of target string

long DOMStringToLong ( | const XalanDOMString & theString )`[]`

Converts a XalanDOMString into a long value.

Parameters:

  theString | target string

Returns:
  long value of target string

unsigned long DOMStringToUnsignedLong ( | const XalanDOMString & theString )`[]`

Converts a XalanDOMString into a long value.

Parameters:

  theString | target string

Returns:
  unsigned long value of target string

const XalanDOMString DoubleToDOMString ( | double theValue )`[]`

Converts a double value into a XalanDOMString.

Parameters:

  theValue | number to be converted

Returns:
  decimal string representation of the number

const XalanDOMString LongToDOMString ( | long theValue )`[]`

Converts a long value into a XalanDOMString.

Parameters:

  theValue | number to be converted

Returns:
  decimal string representation of the number

const XalanDOMString LongToHexDOMString ( | long theValue )`[]`

Converts a long value into a XalanDOMString.

Returns an empty string for negative values.

Parameters:

  theValue | number to be converted

Returns:
  hexadecimal string representation of the number

XalanDOMCharVectorType MakeXalanDOMCharVector ( | const XalanDOMString & data )`[]`

Utility function to make a null-terminated vector of XMLChs, from a XalanDOMString.

Parameters:

  data | XalanDOMString to be converted

Returns:
  null-terminated vector of XalanDOMChar

void OutputString ( | std::ostream & theStream,
| const XalanDOMString & theString )`[]`

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

const XalanDOMString PointerToDOMString ( | const void * theValue )`[]`

Converts a pointer into a XalanDOMString.

Parameters:

  theValue | pointer to be converted

Returns:
  string representation of the pointer

const XalanDOMString & StaticStringToDOMString ( | const XalanDOMString & theString )`[]`

Determines if a range in an array contains only whitespace.

Parameters:

  ch | target array
  start | starting index to examine
  length | number of characters to examine

Returns:
  true if specified range contains only whitespace

const XalanDOMString UnsignedLongToDOMString ( | unsigned long theValue )`[]`

Converts an unsigned long value into a XalanDOMString.

Parameters:

  theValue | number to be converted

Returns:
  decimal string representation of the number

const XalanDOMString UnsignedLongToHexDOMString ( | unsigned long theValue )`[]`

Converts an unsigned long value and appends the result to a XalanDOMString.

Parameters:

  theValue | number to be converted

Returns:
  hexadecimal string representation of the number

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | XalanDOMString ) const

Simulates the java String method substring().

Returns a new string that is a substring of this string. The substring begins at the specified theStartIndex and extends to the character at index theEndIndex - 1. Thus the length of the substring is theEndIndex - theStartIndex.

Parameters:

  theString | source string
  theStartIndex | starting index, inclusive
  theEndIndex | ending index, exclusive

Returns:
  string containing the specified range of characters from target

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | void )

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | void ) const

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | double ) const

Converts a wide string into a double value.

Parameters:

  theString | target string

Returns:
  double value of target string

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | unsigned long ) const

Converts a wide string into an unsigned long value.

Parameters:

  theString | target string

Returns:
  unsigned long value of target string

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | long ) const

Converts a wide string into a long value.

Parameters:

  theString | target string

Returns:
  long value of target string

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | int ) const

Converts a wide string into an integer value.

Parameters:

  theLHS | first array to compare
  theLHSLength | the length of the first array
  theRHS | second array to compare
  theRHSLength | the length of the second array

Returns:
  Returns 0 for equal arrays, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | XalanDOMString & )

Converts a double value into a XalanDOMString.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | XalanDOMString & ) const

Converts a pointer into a XalanDOMString.

Parameters:

  theValue | pointer to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | bool ) const

Simulates the java String method startsWith().

Parameters:

  theString | target string to search
  theStringLength | the length of theString
  theSubstring | substring searched for
  theSubstringLength | the length of theSubstring

Returns:
  true if the target string begins with the substring

XALAN_PLATFORMSUPPORT_EXPORT_FUNCTION ( | XalanDOMString::size_type ) const

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theStringLength | length of the string to search
  theSubstring | substring searched for
  theSubstringLength | length of the substring searched for

Returns:
  the index of theSubstring in theString, or length(theString) if the string is not found.

template<classInputIteratorType, classOutputIteratorType>
OutputIteratorType XalanCopy ( | InputIteratorType begin,
| InputIteratorType end,
| OutputIteratorType iterator )`[]`

template<classInputIteratorType, classOutputIteratorType, classUnaryFunction>
OutputIteratorType XalanTransform ( | InputIteratorType begin,
| InputIteratorType end,
| OutputIteratorType iterator,
| UnaryFunction function )`[]`

XalanDOMString & append ( | XalanDOMString & theString,
| char theCharToAppend )`[]`

Concatenate a string and a character.

Parameters:

  theString | target string
  theCharToAppend | the character to add to the target

Returns:
  string with the character appended

XalanDOMString & append ( | XalanDOMString & theString,
| const XalanDOMChar theCharToAppend )`[]`

Concatenate a string and a character.

Parameters:

  theString | target string
  theCharToAppend | the character to add to the target

Returns:
  string with the character appended

XalanDOMString & append ( | XalanDOMString & theString,
| const char * theStringToAppend,
| XalanDOMString::size_type theStringToAppendLength = XalanDOMString::npos )`[]`

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  string with contents of 'theStringToAppend' added to target string

XalanDOMString & append ( | XalanDOMString & theString,
| const XalanDOMChar * theStringToAppend,
| XalanDOMString::size_type theStringToAppendLength = XalanDOMString::npos )`[]`

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

XalanDOMString & append ( | XalanDOMString & theString,
| const XalanDOMString & theStringToAppend )`[]`

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target

Returns:
  a reference to the target string

XalanDOMString & assign ( | XalanDOMString & theString,
| const XalanDOMChar * theStringToAssign,
| XalanDOMString::size_type theStringToAssignLength = XalanDOMString::npos )`[]`

Assign one string to another.

Parameters:

  theString | target string
  theStringToAppend | string to assign
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

XalanDOMString & assign ( | XalanDOMString & theString,
| const XalanDOMString & theStringToAssign )`[]`

Assign one string to another.

Parameters:

  theString | target string
  theStringToAppend | string to assign
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

const char * c_str ( | const CharVectorType & theString )`[]`

Get the underlying representation of the target CharVectorType as a null-terminated string.

Parameters:

  theString | target string

Returns:
  null-terminated string of chars

const XalanDOMChar * c_wstr ( | const XalanDOMChar * theString )`[]`

Get the underlying representation of the wide string as a UNICODE null-terminated string.

This is here simply for consistency in the code. On certain platforms, compiler- generated wide strings will not contain Unicode code points. Another macro converts those into XalanDOMStrings, which are then transcoded. In these cases, the previous defined c_sstr() function gets called.

On platforms where the compiler does generate Unicode wide strings, this function will be called instead.

Parameters:

  theString | target string

Returns:
  null-terminated string of XalanDOMChar

const XalanDOMChar * c_wstr ( | const XalanDOMString & theString )`[]`

Get the underlying representation of the target XalanDOMString as a null-terminated string.

Parameters:

  theString | target string

Returns:
  null-terminated string of XalanDOMChar

XalanDOMChar charAt ( | const XalanDOMString & theString,
| XalanDOMString::size_type theIndex )`[]`

Retrieves a character at a specified index in the target string.

Parameters:

  theString | target string
  theIndex | index of character

Returns:
  character at specified index

void clear ( | XalanDOMString & theString )`[]`

Remove all elements from target string.

Parameters:

  theString | target string

int collationCompare ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int collationCompare ( | const XalanDOMChar * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int collationCompare ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator< () , compare()

int compare ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compare ( | const XalanDOMChar * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compare ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator< () , collationCompare()

int compareIgnoreCaseASCII ( | const XalanDOMChar * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered for the comparison.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compareIgnoreCaseASCII ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compareIgnoreCaseASCII ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator< , collationCompare

bool endsWith ( | const XalanDOMString & theString,
| const XalanDOMString & theSubstring )`[]`

Simulates the java String method endsWith().

Parameters:

  theString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string ends with the substring

bool equals ( | const char * theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMChar * theLHS,
| const char * theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const char * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMString & theLHS,
| const char * theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS,
| XalanDOMString::size_type theRHSLength )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare
  theRHSLength | the length of the theRHS

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMChar * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals ( | const XalanDOMChar * theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equalsIgnoreCaseASCII ( | const XalanDOMString & theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings for equality, without regard for case.

Only the characters A-Z and a-z are considered.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII ( | const XalanDOMChar * theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Compare the contents of two strings for equality, without regard for case Only the characters A-Z and a-z are considered.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII ( | const XalanDOMChar * theLHS,
| const XalanDOMChar * theRHS )`[]`

Compare the contents of two strings for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if both strings are identical

void erase ( | XalanDOMString & theString )`[]`

Remove all elements from target string.

Parameters:

  theString | target string

XalanDOMString::size_type indexOf ( | const XalanDOMString & theString,
| XalanDOMChar theChar )`[]`

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString::size_type indexOf ( | const XalanDOMChar * theString,
| XalanDOMString::size_type theStringLength,
| XalanDOMChar theChar )`[]`

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theStringLength | the length of theString
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString::size_type indexOf ( | const XalanDOMChar * theString,
| XalanDOMChar theChar )`[]`

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString & insert ( | XalanDOMString & theString,
| XalanDOMString::size_type thePosition,
| const XalanDOMChar * theStringToInsert )`[]`

Insert a string into another string.

Parameters:

  theString | target string
  thePosition | The position in the target string to insert
  theStringToInsert | The string to insert

Returns:
  A reference to the target string

XalanDOMString & insert ( | XalanDOMString & theString,
| XalanDOMString::size_type thePosition,
| const XalanDOMString & theStringToInsert )`[]`

Insert a string into another string.

Parameters:

  theString | target string
  thePosition | The position in the target string to insert
  theStringToInsert | The string to insert

Returns:
  A reference to the target string

bool isEmpty ( | const XalanDOMString & str )`[]`

Determines if the target string contains any elements.

Parameters:

  str | target string

Returns:
  true if the target string has a non-zero length

bool isXMLDigit ( | XalanDOMChar theChar )`[]`

Determines whether character represents a digit.

Parameters:

  theChar | target character

Returns:
  true if character represents a digit

bool isXMLLetterOrDigit ( | XalanDOMChar theChar )`[]`

Determines whether character represents a letter or digit.

Parameters:

  theChar | target character

Returns:
  true if character represents a letter or digit

bool isXMLWhitespace ( | XalanDOMChar theChar )`[]`

Determines whether character represents white space.

Parameters:

  theChar | target character

Returns:
  true if character represents white space

XalanDOMString::size_type length ( | const char * theString )`[]`

Get the length of a null-terminated string.

Parameters:

  theString | target string

Returns:
  the length of the target string

XalanDOMString::size_type length ( | const XalanDOMChar * theString )`[]`

Get the length of a null-terminated string of XalanDOMChar characters.

Parameters:

  theString | target string

Returns:
  the length of the target string

XalanDOMString::size_type length ( | const XalanDOMString & theString )`[]`

Get the length of a XalanDOMString.

Parameters:

  theString | target string

Returns:
  the length of the target string

bool operator< ( | const XalanDOMString & theLHS,
| const XalanDOMString & theRHS )`[]`

Implements operator< for DOMStrings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns true if theLHS is lexically less than theRHS

See also:
  compare

bool operator< ( | const CharVectorType & theLHS,
| const CharVectorType & theRHS )`[]`

Implements operator< for CharVectorType.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns true if theLHS is lexically less than theRHS

See also:
  compare

std::ostream & operator<< ( | std::ostream & theStream,
| const XalanDOMString & theString )`[]`

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString()

XalanOutputStream & operator<< ( | XalanOutputStream & theStream,
| const XalanDOMString & theString )`[]`

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString()

std::ostream & operator<< ( | std::ostream & theStream,
| const XalanDOMChar * theString )`[]`

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString()

XalanOutputStream & operator<< ( | XalanOutputStream & theStream,
| const XalanDOMChar * theString )`[]`

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString()

std::ostream & operator<< ( | std::ostream & theStream,
| const CharVectorType & theString )`[]`

Outputs the string to the specified stream.

Parameters:

  theStream | output stream
  theString | the string to output

See also:
  OutputString()

XalanOutputStream & operator<< ( | XalanOutputStream & theStream,
| const CharVectorType & theString )`[]`

Outputs the string to the specified stream.

Parameters:

  theStream | output stream
  theString | the string to output

See also:
  OutputString()

void releaseMemory ( | XalanDOMString & theString )`[]`

Remove all elements from target string and frees all allocated memory.

Parameters:

  theString | target string

void reserve ( | XalanDOMString & theString,
| XalanDOMString::size_type theCount )`[]`

Reserve some space in the string for more efficient concatenation...

Parameters:

  theString | target string
  theCount | The amount of space to reserve

bool startsWith ( | const XalanDOMString & theString,
| const char * theSubstring )`[]`

Simulates the java String method startsWith().

Parameters:

  theString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith ( | const XalanDOMString & theString,
| const XalanDOMString & theSubstring )`[]`

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith ( | const XalanDOMString & theString,
| const XalanDOMChar * theSubstring,
| XalanDOMString::size_type theSubstringLength )`[]`

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for
  theSubstringLength | the length of theSubstring

Returns:
  true if the target string begins with the substring

bool startsWith ( | const XalanDOMString & theString,
| const XalanDOMChar * theSubstring )`[]`

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith ( | const XalanDOMChar * theString,
| const XalanDOMString & theSubstring )`[]`

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

const char * toCharArray ( | const CharVectorType & theString )`[]`

Get the underlying representation of the target CharVectorType as a pointer to an array of characters.

Parameters:

  theString | target string

Returns:
  the pointer

const XalanDOMChar * toCharArray ( | const XalanDOMChar * theString )`[]`

Get the underlying representation of a XalanDOMChar.

Parameters:

  theString | target string

Returns:
  array of XalanDOMChar

const XalanDOMChar * toCharArray ( | const XalanDOMString & theString )`[]`

Get the underlying representation of the target XalanDOMString as an array of XalanDOMChar, not guaranteed to be null-terminated.

Parameters:

  theString | target string

Returns:
  array of XalanDOMChar

XalanDOMChar toUpperASCII ( | XalanDOMChar theChar )`[]`

Converts ASCII alphabetic characters from lower case to upper case.

This function works only with the Unicode characters a-z.

Parameters:

  theString | target string

Returns:
  string containing upper case characters

## Variable Documentation

XALAN_CPP_NAMESPACE_BEGIN class XalanOutputStream

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.7 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.